<?php
namespace Drupal\vkoembed\Controller;
use Symfony\Component\HttpFoundation\JsonResponse;

/**
 * Class VIDEO api endpoint
 * @package Drupal\vkoembed\Controller
 */
class Video {

  /**
   * @return JsonResponse
   */
  public function index(): JsonResponse {
    $request = \Drupal::request();
    $url = $request->query->get('url');
    $id = $this->extractIdFromUrl($url);

    if ($id) {
      $data = $this->getData($url);
    } else {
      $data = [];
    }
    return new JsonResponse( $data );
  }

  private function extractIdFromUrl(string $url): ?string {
    if (preg_match('#vkvideo.ru/video-([\d]+_[\d]+)#i', $url, $m)) {
      return $m[1];
    }
    return null;
  }

  /**
   * @return array
   */
  private function getData(string $url): array {

    $vkApi = \Drupal::service('vkoembed.vk_api');
    $response = $vkApi->call('video.getOembed', ['url' => $url]);

    if ($response->type == 'video'
      && $response->html
      && $response->thumbnail_url
      && $response->title) {
        return (array) $response;
    } else {
      return [];
    }

  }
}