<?php

namespace Drupal\vkoembed\Hook;

use Drupal\Core\Hook\Attribute\Hook;

/**
 * Hook implementations for vkoembed.
 */
class Hooks
{
  /**
   * Implements oembed_providers_alter().
   */
  #[Hook('oembed_providers_alter')]
  public function oembedProvidersAlter(array &$providers) {
    $request = \Drupal::request();

    $scheme = $request->getScheme();
    $host = $request->getHost();

    $providers[] = [
      'provider_name' => 'VK Video',
      'provider_url' => 'https://vkvideo.ru/',
      'endpoints' => [
        [
          'schemes' => [
            'https://vkvideo.ru/video*',
          ],
          'url' => $scheme . '://' . $host . '/vkoembed/api/getVideo',
          'discovery' => 'true',
        ],
      ],
    ];
  }
}
