<?php

namespace Drupal\vkoembed;

class VkApi {
  const API_URL = 'https://api.vk.com/method/';
  const API_VERSION = '5.199';

  function call(string $APImethod, array $params) {

    $params['v'] = self::API_VERSION;

    $url = self::API_URL . $APImethod . '?' . http_build_query($params);
    $ch = curl_init($url);

    $config = \Drupal::config('vk.api.setting');
    $token = $config->get('vk_key');
    $authorization = "Authorization: Bearer " . $token;

    curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/x-www-form-urlencoded', $authorization]);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, 1);
//    curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    $result = json_decode(curl_exec($ch));
    curl_close($ch);

    if (!empty($result) && !empty($result->error)) {
      \Drupal::logger('vk api')->error('API request error. URL: %url. RESULT: %response', ['%url' => $url, '%response' => serialize($result)]);
      return $result;
    } else {
      return $result->response;
    }
  }

}